#backend
import math
import pygame
import random

WINDOW_SIZE = (1200, 600)


class clicable_tekst:
    def __init__(self,text,font,x,y,color='white',active_color='yellow'):
        self.text=text
        self.font=font
        self.color_beg=color
        self.color=color
        self.pos=[x,y]
        self.activ_color=active_color
        self.image=self.font.render(self.text,True,self.color)
        self.rect=self.image.get_rect()
        self.rect.center=self.pos
    def draw(self,screen):
        self.image=self.font.render(self.text,True,self.color)
        screen.blit(self.image,self.rect)
    def update(self,mouse_pos):
        if self.rect.collidepoint(mouse_pos):
            self.color = self.activ_color
        else:
            self.color = self.color_beg
    def click(self,mouse_pos):
        if self.rect.collidepoint(mouse_pos):
            return True

class shinig_star:
    def __init__(self,y,x=WINDOW_SIZE[0],size=25,speed_moving=3,speed_shining=4):
        self.speed_x=speed_moving
        self.speed_sprite=speed_shining
        self.witch=0
        self.pos=[x,y]
        self.size=[size,size]
        self.rect=pygame.Rect(self.pos[0],self.pos[1],self.size[0],self.size[1])
        self.sprite_star_1= pygame.image.load('sprite\G1.png')
        self.sprite_star_1= pygame.transform.scale(self.sprite_star_1, self.size)

        self.sprite_star_2= pygame.image.load('sprite\G2.png')
        self.sprite_star_2= pygame.transform.scale(self.sprite_star_2, self.size)

        self.sprite_star_3= pygame.image.load('sprite\G3.png')
        self.sprite_star_3= pygame.transform.scale(self.sprite_star_3, self.size)

        self.sprite_star_4= pygame.image.load('sprite\G4.png')
        self.sprite_star_4= pygame.transform.scale(self.sprite_star_4, self.size)

        self.sprite_star_5= pygame.image.load('sprite\G5.png')
        self.sprite_star_5= pygame.transform.scale(self.sprite_star_5, self.size)

        self.sprite_star_6= pygame.image.load('sprite\G6.png')
        self.sprite_star_6= pygame.transform.scale(self.sprite_star_6, self.size)

        self.sprite_star_7= pygame.image.load('sprite\G7.png')
        self.sprite_star_7= pygame.transform.scale(self.sprite_star_7, self.size)
        
        self.sprite=[
            self.sprite_star_1,
            self.sprite_star_2,
            self.sprite_star_3,
            self.sprite_star_4,
            self.sprite_star_5,
            self.sprite_star_6,
            self.sprite_star_7
        ]

    def update(self):
        self.pos[0]=self.pos[0]-self.speed_x        
        self.rect.center=(self.pos)

    def draw(self, screen):
        screen.blit(self.sprite[int(math.floor(self.witch/self.speed_sprite))], self.pos)
        self.witch=self.witch+1
        if self.witch==self.speed_sprite*7:
                    self.witch=0

class stars_cons:
    def __init__(self,y_min=0,y_max=WINDOW_SIZE[1]):
        self.y_min=y_min
        self.y_max=y_max
        self.stars=[]
    
    def clear_star(self):
        self.stars.clear()

    def add_star(self):
        y=random.randint(self.y_min,self.y_max)
        starr=shinig_star(y)
        self.stars.append(starr)

    def update(self):
        for star in self.stars[:]:
            star.update()
            if star.pos[0]+star.size[0]<0:
                self.stars.remove(star)
            
    def draw(self,screen):
        for star in self.stars:
            star.draw(screen)
    
    def speed_up(self, speed):
        for star in self.stars:
            star.speed_x=speed

class konfetti:
    def __init__(self,x,speed_pocz_x,speed_pocz_y,a_y,size_min=2,size_max=5):
        self.size=random.randint(size_min,size_max)
        self.x=x
        self.y=WINDOW_SIZE[1]
        self.speed_x=speed_pocz_x
        self.speed_y=speed_pocz_y

        self.a_y=a_y
        self.color=random.choice([
            (255,0,0),  
            (0,255,0),    
            (0,0,255),    
            (255,255,0),  
            (255,0,255), 
            (0,255,255),  
            (255,255,255)
        ])
        self.angel=random.randint(0,360)

        #w necie znalazlem

        self.image = pygame.Surface((self.size, self.size), pygame.SRCALPHA)
        
        pygame.draw.rect(self.image, self.color, self.image.get_rect())
        
        self.rotated_image = pygame.transform.rotate(self.image, self.angel)
        
        self.rect = self.rotated_image.get_rect(center=(self.x, self.y))

    def update(self):
        self.y=self.y+self.speed_y
        self.x=self.x+self.speed_x

        self.speed_y=self.speed_y+self.a_y
        
        self.rect.center=(self.x,self.y)

    def draw(self, screen):
        screen.blit(self.rotated_image, self.rect)

class konfetti_tube:
    def __init__(self,maxx):
        self.maxx=maxx
        self.list=[]

    def create_row(self,max=25,min=1):
        limit=random.randint(min,max)
        i=0
        while i<limit:
            random_x=random.randint(0,self.maxx)
            random_speed_x=random.randint(0,10)
            random_speed_x=random_speed_x+random.random()
            randomi=random.randint(1,2)
            if randomi==1:
                random_speed_x=-1*random_speed_x
            random_speed_y=random.randint(-10,0)
            random_speed_y=random_speed_y-random.random()
            random_speed_ay=random.randint(15,35)*1.0
            random_speed_ay=random_speed_ay/1000
            kon=konfetti(300,random_speed_x,random_speed_y,random_speed_ay)
            
            self.list.append(kon)
            i=i+1
        limit=random.randint(min,max)
        i=0
        while i<limit:
            random_x=random.randint(0,self.maxx)
            random_speed_x=random.randint(0,10)
            random_speed_x=random_speed_x+random.random()
            randomi=random.randint(1,2)
            if randomi==1:
                random_speed_x=-1*random_speed_x
            random_speed_y=random.randint(-10,0)
            random_speed_y=random_speed_y-random.random()
            random_speed_ay=random.randint(5,45)*1.0
            random_speed_ay=random_speed_ay/1000
            kon=konfetti(900,random_speed_x,random_speed_y,random_speed_ay)
            
            self.list.append(kon)
            i=i+1

    def update(self):
        for kon in self.list[:]:
            kon.update()
            if kon.y>=WINDOW_SIZE[1]:
                self.list.remove(kon)
    
    def draw(self,screen):
        for kon in self.list:
            kon.draw(screen)

class Asteroid_Belt:
    def __init__(self, max_asteroids=20, 
                min_level=3, max_level=5, 
                min_size=50, max_size=50+50,
                min_speed=6, max_speed=8):
        self.min_level=min_level
        self.max_level=max_level
        self.min_size=min_size
        self.max_size=max_size
        self.min_speed=min_speed
        self.max_speed=max_speed
        self.max_asteroids=max_asteroids
        self.asteroids=[]
        self.pickups=[]

    def spawn_asteroid(self):
        if len(self.asteroids)<self.max_asteroids:
            size=random.randint(self.min_size, self.max_size)
            level=random.randint(self.min_level, self.max_level)
            speed=random.randint(int(2*self.min_speed), int(2*self.max_speed))/2
            starting_pos_x=WINDOW_SIZE[0]
            starting_pos_y=random.randint(0, WINDOW_SIZE[1]-size)
            new_asteroid=Asteroid(size=size, level=level,speed=speed, 
                                  x=starting_pos_x, y=starting_pos_y)
            self.asteroids.append(new_asteroid)

    def update(self):
        for asteroid in self.asteroids[:]:
            asteroid.update()
            if asteroid.pos[0]+2*asteroid.size<0:
                self.asteroids.remove(asteroid)
        for pickup in self.pickups[:]:
            pickup.update()
            if pickup.pos[0]+pickup.size[0]<0:
                self.pickups.remove(pickup)

    def collision_bullet(self, bullets): 
        pkt=0
        for bulle in bullets.bullets[:]:
            for asteroid in self.asteroids[:]:
                if bulle.rect.colliderect(asteroid.rect):
                    asteroid.take_a_hit(bulle.dmg)
                    bullets.bullets.remove(bulle)
                    if asteroid.dead():
                        self.asteroids.remove(asteroid)
                        pkt=pkt+asteroid.starsting_lvl
                        chance = random.random()
                        if chance <= 0.10:
                            self.spawn_torpedo_pickup(asteroid)
                        elif chance<=0.15:
                            self.spawn_heart_pickup(asteroid)                            
                        elif chance<=0.20:
                            self.spawn_star_pickup(asteroid)
                        break
        return pkt

    def collision_pickup(self, ship):
        pick=[]
        for pickup in self.pickups[:]:
            if ship.rect.colliderect(pickup.rect):
                if isinstance(pickup, TorpedoPickup):
                    self.pickups.remove(pickup)
                    pick.append('torpedo')
                elif isinstance (pickup, HeartPickup):
                    self.pickups.remove(pickup)
                    pick.append('heart')
                elif isinstance (pickup, StarPickup):
                    self.pickups.remove(pickup)
                    pick.append('star')
        return pick

    def collision_player(self,player):    
        for asteroid in self.asteroids[:]:
            if player.rect.colliderect(asteroid.rect):
                if player.imunity==False:
                    self.asteroids.remove(asteroid)
                return True
                
        return False

    def spawn_torpedo_pickup(self, asteroid):
        new_pickup = TorpedoPickup(
            x = asteroid.pos[0],
            y = asteroid.pos[1],
            speed = asteroid.speed
        )
        self.pickups.append(new_pickup)

    def spawn_heart_pickup(self, asteroid):
        new_pickup = HeartPickup(
            x = asteroid.pos[0],
            y = asteroid.pos[1],
            speed = asteroid.speed
        )
        self.pickups.append(new_pickup)

    def spawn_star_pickup(self, asteroid):
        new_pickup = StarPickup(
            x = asteroid.pos[0],
            y = asteroid.pos[1],
            speed = asteroid.speed
        )
        self.pickups.append(new_pickup)

    def draw(self,screen):
        for asteroid in self.asteroids:
            percet=asteroid.level/asteroid.starsting_lvl
            colorek=(255,0,0)
            colorek_tlo=(144,144,144)
            if percet!=1:
                rect_bar=(asteroid.rect.center[0]-25,asteroid.rect.bottomleft[1]+5,50,10)
                rect_hp=(asteroid.rect.center[0]-25,asteroid.rect.bottomleft[1]+5,50*percet,10)
                pygame.draw.rect(screen,colorek_tlo, rect_bar)
                pygame.draw.rect(screen,colorek, rect_hp)
            asteroid.draw(screen)

        for pickup in self.pickups:
            pickup.draw(screen)

class Kaa_Boom:
    def __init__(self,pos_center,n=10,m=60,size=150):
        self.size=[size,size]
        self.pos=pos_center
        self.sprite=[]
        self.rect=[]
        self.witch=0
        self.show=True
        self.n=n
        self.m=m
        i=0
        while i<10:
            sprite_tmp=pygame.image.load('sprite\Z'+str(i)+'.png')
            sprite_tmp=pygame.transform.scale(sprite_tmp, self.size)
            self.sprite.append(sprite_tmp)
            rect_tmp=pygame.Rect(0,0,self.size[0],self.size[1])
            rect_tmp.center=self.pos
            self.rect.append(rect_tmp)
            i=i+1
    
    def set_center(self,pos_center):
        self.pos=pos_center
        for rect in self.rect:
            rect.center=self.pos
        
    
    def draw(self,screen):
        if self.show:
            screen.blit(self.sprite[int(math.floor(self.witch/(self.m/self.n)))], self.rect[int(math.floor(self.witch/(self.m/self.n)))].topleft)
        self.witch=self.witch+1
        if self.witch>=self.m:
                    self.show=False
                    self.remove()

    def remove(self):
        for spr in self.sprite:
            spr.fill((0, 0, 0, 0))
    def clear(self):
        self.witch=0
        self.show=True
        
class Asteroid:
    def __init__(self,size=50,level=3,speed=10,x=WINDOW_SIZE[0],y=WINDOW_SIZE[1]/2):
        self.size=size
        self.level=level*1.0
        self.starsting_lvl=self.level
        self.pos=[x,y]  
        self.witch=0
        self.speed=speed
        if self.level==3:
            self.sprite_A = pygame.image.load('sprite\A1.png')
            self.sprite_A=pygame.transform.scale(self.sprite_A, (self.size, self.size))
            
        elif  self.level==4:
            self.sprite_A = pygame.image.load('sprite\A2.png')
            self.sprite_A=pygame.transform.scale(self.sprite_A, (self.size, self.size))
        elif  self.level==5:
            self.sprite_A = pygame.image.load('sprite\A3.png')
            self.sprite_A=pygame.transform.scale(self.sprite_A, (self.size, self.size))
        self.sprite_O1 = pygame.image.load('sprite\O1.png')
        self.sprite_O1=pygame.transform.scale(self.sprite_O1, (2*self.size, self.size))

        self.sprite_O2 = pygame.image.load('sprite\O2.png')
        self.sprite_O2=pygame.transform.scale(self.sprite_O2, (2*self.size, self.size))   

        self.sprite_O3 = pygame.image.load('sprite\O3.png')
        self.sprite_O3=pygame.transform.scale(self.sprite_O3, (2*self.size, self.size))   

        
        self.sprite_O=[self.sprite_O1,self.sprite_O2,self.sprite_O3,self.sprite_O2]     

        self.rect=pygame.Rect(self.pos[0],self.pos[1],self.size,self.size)


    def update(self):
        self.pos[0]=self.pos[0]-self.speed
        self.rect.x=self.pos[0]
        
    def take_a_hit(self,dmg=1):
        self.level=self.level-dmg
        if self.level<=0:
            self.level=0

    def dead(self):
        if self.level<=0:
            ast_sound = pygame.mixer.Sound('music\steroid.mp3')
            ast_sound.play()
            return True
        else:
            return False

    def return_kolor(self):
        levelik=int(math.ceil(self.level))
        if levelik<=0:
            return(0,0,0)
        return ((6-levelik)*50,0,0)
        
    def draw(self,screen):
        screen.blit(self.sprite_A, self.pos)
        screen.blit(self.sprite_O[int(math.floor(self.witch/6))], self.pos)
        self.witch=self.witch+1
        if self.witch==24:
                    self.witch=0
    
class TorpedoPickup:
    def __init__(self, x, y, speed,size=50):
        self.size=[size,size]
        self.pos=[x,y]
        self.speed=speed
        self.witch=0
        self.sprite_topedo_1= pygame.image.load('sprite\pickupA1.png')
        self.sprite_topedo_2= pygame.image.load('sprite\pickupA2.png')
        self.sprite_topedo_3= pygame.image.load('sprite\pickupA3.png')
        self.sprite_topedo_4= pygame.image.load('sprite\pickupA4.png')
        
        self.sprite_topedo_1= pygame.transform.scale(self.sprite_topedo_1,self.size)
        self.sprite_topedo_2= pygame.transform.scale(self.sprite_topedo_2,self.size)
        self.sprite_topedo_3= pygame.transform.scale(self.sprite_topedo_3,self.size)
        self.sprite_topedo_4= pygame.transform.scale(self.sprite_topedo_4,self.size)

        self.sprite_topedo=[self.sprite_topedo_1,self.sprite_topedo_2,self.sprite_topedo_3,self.sprite_topedo_4]

        self.rect=pygame.Rect(self.pos[0],self.pos[1],self.size[0],self.size[1])

    def update(self):
        self.pos[0]=self.pos[0]-self.speed
        self.rect.x=self.pos[0]

    def draw(self, screen):
        screen.blit(self.sprite_topedo[int(math.floor(self.witch/6))], self.pos)
        self.witch=self.witch+1
        if self.witch==24:
                    self.witch=0
        #pygame.draw.rect(screen, (0, 0, 255), self.rect)

class HeartPickup:
    def __init__(self, x, y, speed,size=50):
        self.size=[size,size]
        self.pos=[x,y]
        self.speed=speed
        self.witch=0
        self.sprite_heart_1= pygame.image.load('sprite\pickupB1.png')
        self.sprite_heart_2= pygame.image.load('sprite\pickupB2.png')
        self.sprite_heart_3= pygame.image.load('sprite\pickupB3.png')
        self.sprite_heart_4= pygame.image.load('sprite\pickupB4.png')
        
        self.sprite_heart_1= pygame.transform.scale(self.sprite_heart_1,self.size)
        self.sprite_heart_2= pygame.transform.scale(self.sprite_heart_2,self.size)
        self.sprite_heart_3= pygame.transform.scale(self.sprite_heart_3,self.size)
        self.sprite_heart_4= pygame.transform.scale(self.sprite_heart_4,self.size)

        self.sprite_heart=[self.sprite_heart_1,self.sprite_heart_2,self.sprite_heart_3,self.sprite_heart_4]

        self.rect=pygame.Rect(self.pos[0],self.pos[1],self.size[0],self.size[1])

    def update(self):
        self.pos[0]=self.pos[0]-self.speed
        self.rect.x=self.pos[0]

    def draw(self, screen):
        screen.blit(self.sprite_heart[int(math.floor(self.witch/6))], self.pos)
        self.witch=self.witch+1
        if self.witch==24:
                    self.witch=0
        #pygame.draw.rect(screen, (0, 0, 255), self.rect)

class StarPickup:
    def __init__(self, x, y, speed,size=50):
        self.size=[size,size]
        self.pos=[x,y]
        self.speed=speed
        self.witch=0
        self.sprite_star_1= pygame.image.load('sprite\pickupC1.png')
        self.sprite_star_2= pygame.image.load('sprite\pickupC2.png')
        self.sprite_star_3= pygame.image.load('sprite\pickupC3.png')
        self.sprite_star_4= pygame.image.load('sprite\pickupC4.png')
        
        self.sprite_star_1= pygame.transform.scale(self.sprite_star_1,self.size)
        self.sprite_star_2= pygame.transform.scale(self.sprite_star_2,self.size)
        self.sprite_star_3= pygame.transform.scale(self.sprite_star_3,self.size)
        self.sprite_star_4= pygame.transform.scale(self.sprite_star_4,self.size)

        self.sprite_star=[self.sprite_star_1,self.sprite_star_2,self.sprite_star_3,self.sprite_star_4]

        self.rect=pygame.Rect(self.pos[0],self.pos[1],self.size[0],self.size[1])

    def update(self):
        self.pos[0]=self.pos[0]-self.speed
        self.rect.x=self.pos[0]

    def draw(self, screen):
        screen.blit(self.sprite_star[int(math.floor(self.witch/6))], self.pos)
        self.witch=self.witch+1
        if self.witch==24:
                    self.witch=0
        #pygame.draw.rect(screen, (0, 0, 255), self.rect)

class Ship:
    def __init__(self,x=0,y=WINDOW_SIZE[1]/2,size=50,speed=10,hp=6):
        self.size=size
        self.pos=[x,y] 
        self.speed=speed
        self.rect=pygame.Rect(self.pos[0],self.pos[1],self.size,self.size)
        self.hp=hp
        self.imunity=False
        self.imunity_time=0
        self.blink=False

    def move(self, keys, width=WINDOW_SIZE[0],height=WINDOW_SIZE[1]):
        if keys[pygame.K_UP]:
            self.pos[1]=self.pos[1]-self.speed
            if self.pos[1]<=0:
                self.pos[1]=0
        if keys[pygame.K_DOWN]:
            self.pos[1]=self.pos[1]+self.speed
            if self.pos[1]>=height-self.size:
                self.pos[1]=height-self.size
        if keys[pygame.K_RIGHT]:
            self.pos[0]=self.pos[0]+self.speed
            if self.pos[0]>=width-self.size:
                self.pos[0]=width-self.size
        if keys[pygame.K_LEFT]:
            self.pos[0]=self.pos[0]-self.speed
            if self.pos[0]<=0:
                self.pos[0]=0
        self.rect.topleft=(self.pos[0], self.pos[1])

    def update(self):
        if self.imunity:
            self.imunity_timer=self.imunity_timer+1
            if self.imunity_timer >= 2*60: 
                self.imunity = False
                self.imunity_timer = 0
                self.blink = False
            else:
                if self.imunity_timer % 10 == 0:
                    self.blink = not self.blink
    
    def is_visible(self):
        return not self.imunity or self.blink
    
    def collision_check(self):
        if not self.imunity:
            self.hp=self.hp - 1
            self.imunity = True
            dmg_sound = pygame.mixer.Sound('music\hit_taken.mp3')
            dmg_sound.set_volume(0.25)
            dmg_sound.play()
            self.imunity_timer = 0
            if self.hp < 0:
                self.hp = 0 

class Bullet:
    def __init__(self, x,y,size_x=5,size_y=3,speed=12,dmg=1):
        self.pos=[x,y]  
        self.speed=speed
        self.size=[size_x,size_y] 
        self.dmg=dmg
        self.rect=pygame.Rect(self.pos[0],self.pos[1],self.size[0],self.size[1])

    def update(self):
        self.pos[0]=self.pos[0]+self.speed
        self.rect.x=self.pos[0]

    def draw(self,screen):
        pygame.draw.rect(screen, (255,255,0),self.rect)

class Bullet_List:
    def __init__(self):
        self.bullets=[]

    def add_bullet(self, x,y,size_x=5,size_y=3,speed=12):
        new_bulet=Bullet(x,y,size_x=size_x,size_y=size_y,speed=speed)
        self.bullets.append(new_bulet)

    def update(self):
        for bullet in self.bullets[:]:
            bullet.update()
            if bullet.pos[0]+bullet.size[0]>WINDOW_SIZE[0]:
                self.bullets.remove(bullet)

    def draw(self,screen):
        for bullet in self.bullets:
            bullet.draw(screen)

class Laser:
    def __init__(self, x,y,size=12,dmg=0.25):
        self.activate=False
        self.pos=[x,y] 
        self.dmg=dmg
        self.size=size
        self.num=0
        self.rect=pygame.Rect(self.pos[0],self.pos[1]-5,WINDOW_SIZE[0]-self.pos[0],self.size)
        self.charge_time = 15*60
        self.usage_time = 5*60
        self.current_charge = self.charge_time
        self.current_usage = 0
        self.is_charging = False
        self.is_ready = True
        self.sprite_ship_laser=pygame.image.load('sprite\Shot_w.png') 
        self.sprite_ship_laser=pygame.transform.scale(self.sprite_ship_laser, (64, 12))

    def update(self, asteroid_belt, ship_center):
        pkt=0
        self.pos=[ship_center[0], ship_center[1]]
        self.rect=pygame.Rect(self.pos[0]+self.num, self.pos[1]-6, WINDOW_SIZE[0]-self.pos[0],self.size)
        self.num=self.num+1
        if self.num==12:
            self.num=0
        if self.activate and self.is_ready:
            self.current_usage = self.current_usage+1
            if self.current_usage >= self.usage_time:
                self.activate = False
                self.is_ready = False
                self.is_charging = True
                self.current_usage = 0
                self.current_charge = 0
            else:
                for asteroid in asteroid_belt.asteroids[:]:
                    if self.rect.colliderect(asteroid.rect):
                        asteroid.take_a_hit(self.dmg)
                        if asteroid.dead():
                            asteroid_belt.asteroids.remove(asteroid)
                            pkt=pkt+asteroid.starsting_lvl
                            chance = random.random()
                            if chance <= 0.10:
                                asteroid_belt.spawn_torpedo_pickup(asteroid)
                            elif chance <= 0.15:
                                asteroid_belt.spawn_heart_pickup(asteroid)
                            elif chance <= 0.20:
                                asteroid_belt.spawn_star_pickup(asteroid)
        else:
            if self.is_charging:
                self.current_charge =self.current_charge + 1
                if self.current_charge >= self.charge_time:
                    self.is_charging = False
                    self.is_ready = True
                    self.current_charge = self.charge_time
        return pkt

    def draw(self, screen):
        if self.activate:
            sprite_width=self.sprite_ship_laser.get_width()
            num_sprites=math.ceil(self.rect.width / sprite_width)
            for i in range(num_sprites):
                x_pos = self.rect.left + i * sprite_width
                screen.blit(self.sprite_ship_laser, (x_pos, self.rect.top))

class Torpedo:
    def __init__(self,x,y,speed,size_x,size_y,exp_size=200,exp_time=5,dmg=5):
        self.pos=[x,y]  
        self.speed=speed
        self.size=[size_x,size_y] 
        self.rect=pygame.Rect(self.pos[0],self.pos[1],self.size[0],self.size[1])
        self.exploded=False
        self.exp_time=exp_time
        self.current_time=0
        self.size_exp=exp_size
        self.dmg=dmg
        self.sprite_topedo= pygame.image.load('sprite\Topedo_1.png')
        self.sprite_topedo_1= pygame.image.load('sprite\Topedo_back_1.png')
        self.sprite_topedo_2= pygame.image.load('sprite\Torpedo_back_2.png')
        self.witch=0
        self.sprite_topedo= pygame.transform.scale(self.sprite_topedo, self.size)
        self.sprite_topedo_1= pygame.transform.scale(self.sprite_topedo_1, (self.size[0]+12,self.size[1]+2))
        self.sprite_topedo_2= pygame.transform.scale(self.sprite_topedo_2, (self.size[0]+12,self.size[1]+2))

    def update(self):
        if not self.exploded:
            self.pos[0]=self.pos[0]+self.speed
            self.rect.x=self.pos[0]
        else:
            self.current_time=self.current_time+1

    def explode(self,asteroid_belt):
        pkt=0
        c_x, c_y = self.rect.center
        sizeler=self.size_exp
        exp_rect=pygame.Rect(c_x - sizeler/2, c_y - sizeler/2 , sizeler, sizeler)
        if self.current_time==1:
            exp_sound = pygame.mixer.Sound('music\explode.mp3')
            exp_sound.set_volume(0.15)
            exp_sound.play()
        for asteroid in asteroid_belt.asteroids[:]:
            if exp_rect.colliderect(asteroid.rect):
                asteroid.take_a_hit(self.dmg)
                if asteroid.dead():
                    asteroid_belt.asteroids.remove(asteroid)
                    pkt=pkt+asteroid.starsting_lvl
                    chance = random.random()
                    if chance <= 0.10:
                        asteroid_belt.spawn_torpedo_pickup(asteroid)
                    elif chance <= 0.15:
                        asteroid_belt.spawn_heart_pickup(asteroid)
                    elif chance <= 0.20:
                        asteroid_belt.spawn_star_pickup(asteroid)
        return pkt

    def draw(self,screen):
        if not self.exploded:
            screen.blit(self.sprite_topedo,self.pos)
            if self.witch<4:
                screen.blit(self.sprite_topedo_1,(self.pos[0]-12,self.pos[1]-1))
            else:
                screen.blit(self.sprite_topedo_2,(self.pos[0]-12,self.pos[1]-1))
            self.witch=self.witch+1
            if self.witch>=8:
                self.witch=0
            #pygame.draw.rect(screen,(0,0,255),self.rect)
        else:
            c_x, c_y = self.rect.center
            kolor=(255,255,255)
            thick=5
            sizeler=(self.size_exp/self.exp_time)*self.current_time

            pygame.draw.line(screen, kolor, (c_x- sizeler, c_y - sizeler), (c_x +sizeler, c_y - sizeler), thick)
            pygame.draw.line(screen, kolor, (c_x +sizeler, c_y - sizeler), (c_x +sizeler, c_y+sizeler), thick)
            pygame.draw.line(screen, kolor, (c_x +sizeler, c_y+sizeler), (c_x- sizeler, c_y+sizeler), thick)
            pygame.draw.line(screen, kolor, (c_x- sizeler, c_y+sizeler), (c_x- sizeler, c_y - sizeler), thick)

class Torpedo_list:
    def __init__(self):
        self.torpedos=[]

    def add(self,x,y,speed,size_x,size_y,exp_size=200,exp_time=5):
        new_torpedo=Torpedo(x,y,speed,size_x,size_y,exp_size=exp_size,exp_time=exp_time)
        self.torpedos.append(new_torpedo)

    def update(self,asteroid_belt):
        pkt=0
        for torpedo in self.torpedos[:]:
            if torpedo.current_time>=torpedo.exp_time:
                self.torpedos.remove(torpedo)
            torpedo.update()
            if torpedo.pos[0]+torpedo.size[0]>WINDOW_SIZE[0]:
                self.torpedos.remove(torpedo)
            if torpedo.exploded:
                pkt=pkt+torpedo.explode(asteroid_belt)
            for asteroid in asteroid_belt.asteroids[:]:
                    if torpedo.rect.colliderect(asteroid.rect):
                        torpedo.exploded=True
        return pkt

    def draw(self,screen):
        for torpedo in self.torpedos:
            torpedo.draw(screen)

def update_high_score(new_score, file_name='high_score.txt'):
    new_score=int(new_score)
    try:
        with open(file_name, 'r') as file:
            scores = [int(line.strip()) for line in file.readlines()]
    except FileNotFoundError:
        scores = []  

    scores.append(new_score)
    scores = sorted(scores, reverse=True)
    while len(scores)>10:
        scores.pop()
    with open(file_name, 'w') as file:
        for score in scores:
            file.write(f"{score}\n")

def get_high_score( file_name='high_score.txt'):
    try:
        with open( file_name, 'r') as file:
            scores = [int(line.strip()) for line in file.readlines()]
        return sorted(scores, reverse=True)
    except FileNotFoundError:
        return []  