#frontend
import pygame
import random
import os
import math
import numpy as np
from backend import (
    clicable_tekst,
    Asteroid,
    Asteroid_Belt,
    Ship,
    Bullet_List,
    Laser,
    Torpedo_list,
    get_high_score,
    konfetti,
    konfetti_tube,
    update_high_score,
    shinig_star,
    stars_cons,
    Kaa_Boom
)

WINDOW_SIZE = (1200, 600)
FONT1_SIZE = 12
FONT1_BOLD = False

FONT2_SIZE = 36
FONT2_BOLD = True

FONT3_SIZE = 48
FONT3_BOLD = True

class MainApp:
    def __init__(self):
        
        pygame.mixer.init()
        self.score_board=False
        self.explain=False
        pygame.mixer.music.load('music\space-adventure.mp3')
        pygame.mixer.music.play(-1)
        self.total_distance=0
        os.environ['SDL_VIDEO_CENTERED'] = "1"
        pygame.display.set_caption("SPACE TREK" + " in " + os.getcwd())
        self.constelation=stars_cons()
        CENTER_POINT=(WINDOW_SIZE[0]/2,WINDOW_SIZE[1]/2)
        self.screen = pygame.display.set_mode(WINDOW_SIZE)
        self.once=False
        pygame.init()

        self.clock = pygame.time.Clock()

        self.font1 = pygame.font.Font('PressStart2P-Regular.ttf',FONT1_SIZE)
        self.font1.set_bold(FONT1_BOLD)
        self.font2 = pygame.font.Font('PressStart2P-Regular.ttf',FONT2_SIZE)
        self.font2.set_bold(FONT2_BOLD)
        self.font3 = pygame.font.Font('PressStart2P-Regular.ttf',FONT3_SIZE)
        self.font3.set_bold(FONT3_BOLD)
        
        self.ship_size = 100
        self.asteroid_size = 50

        self.sprite_ship_1= pygame.image.load('sprite\Statek_1.png')
        self.sprite_ship_1= pygame.transform.scale(self.sprite_ship_1, (self.ship_size+16,self.ship_size+16))

        self.sprite_ship_2= pygame.image.load('sprite\Statek_2.png')
        self.sprite_ship_2= pygame.transform.scale(self.sprite_ship_2, (self.ship_size+16,self.ship_size+16))

        self.sprite_ship_3= pygame.image.load('sprite\Statek_3.png')
        self.sprite_ship_3= pygame.transform.scale(self.sprite_ship_3, (self.ship_size+16,self.ship_size+16))

        self.sprite_ship_shot= pygame.image.load('sprite\Space_shot.png')
        self.sprite_ship_shot= pygame.transform.scale(self.sprite_ship_shot, (self.ship_size+16,self.ship_size+16))
        
        self.sprite_ship_up_torpedo= pygame.image.load('sprite\Statek_torpedo_up.png')
        self.sprite_ship_up_torpedo= pygame.transform.scale(self.sprite_ship_up_torpedo, (self.ship_size+16,self.ship_size+16))
        
        self.sprite_ship_down_torpedo= pygame.image.load('sprite\Statek_torpedo_down.png')
        self.sprite_ship_down_torpedo= pygame.transform.scale(self.sprite_ship_down_torpedo, (self.ship_size+16,self.ship_size+16))

        self.sprite_ship_both_torpedo= pygame.image.load('sprite\Topego_statek_2.png')
        self.sprite_ship_both_torpedo= pygame.transform.scale(self.sprite_ship_both_torpedo, (self.ship_size+16,self.ship_size+16))

        self.was_shot=0

        self.sprite_ship_laser= pygame.image.load('sprite\Shot_w.png')
        self.sprite_ship_laser= pygame.transform.scale(self.sprite_ship_laser, (32,6))

        self.statek_sprites=[self.sprite_ship_1,self.sprite_ship_2,self.sprite_ship_3,self.sprite_ship_2]

        self.witch_sprite_ship=0

        self.space_sound = pygame.mixer.Sound('music\space_bar.mp3')
        self.q_sound = pygame.mixer.Sound('music\q_sound.mp3')
        self.w_loop_sound = pygame.mixer.Sound('music\w_loop.mp3')

        self.won_sound = pygame.mixer.Sound('music\you_won.mp3')
        self.game_over_sound = pygame.mixer.Sound('music\game_over.mp3')
        self.start_sound = pygame.mixer.Sound('music\game_start.mp3')

        self.space_sound.set_volume(0.5)
        self.w_loop_sound.set_volume(0.25)

        self.w_loop_channel = None

        self.warp=1.0
        self.background_T1=pygame.image.load('sprite\T1.png')
        self.background_T2=pygame.image.load('sprite\T2.png')

        self.background_width, self.background_height = self.background_T1.get_size()

        self.background_x_T1=0
        self.background_x_T2=0

        self.background_speed_T1=0.25
        self.background_speed_T2=0.5
        
        self.background_speed_2=2
        self.background_speed_3=3

        self.player_speed=10
        self.bullet_speed=12
        self.torpedo_speed=11

        self.asteroid_min_speed=8
        self.asteroid_max_speed=8

        self.ship = Ship(x=0, y=WINDOW_SIZE[1]/2, size=self.ship_size, speed=self.player_speed)

        self.bullet_list = Bullet_List()
        self.konfett_list = konfetti_tube(WINDOW_SIZE[0])
        self.kon_t=0

        self.laser = Laser(self.ship.pos[0], self.ship.pos[1])

        self.torpedo_list = Torpedo_list()

        self.asteroid_list=Asteroid_Belt(min_speed=self.asteroid_min_speed, max_speed=self.asteroid_max_speed)

        self.bullet_size=5

        self.running=True
        self.game_over=False
        self.game_won=False
        self.menu_is=True

        self.total_score=0

        self.spawn_max=500
        self.spawn_min=100

        self.time_to_spawn = random.randint(self.spawn_min, self.spawn_max)

        self.event_spawn_ateroid = pygame.USEREVENT + 1
        self.kaboo=Kaa_Boom(self.ship.rect.center)
        pygame.time.set_timer(self.event_spawn_ateroid, self.time_to_spawn)
        
        self.sparkels_1=[]

        self.pppk=0

        self.has_top_torpedo=True
        self.has_bottom_torpedo=True

        iintto=0
        while iintto<=WINDOW_SIZE[0]:
            iinnttt=random.randint(0, 5)
            ittt=0
            while ittt<iinnttt:
                kolor_innit=random.randint(1, 3)
                if kolor_innit==1:
                    kint=(255,0,0)
                elif kolor_innit==2:
                    kint=(204,255,255)
                elif kolor_innit==3:
                    kint=(204,255,204)
                posinit=random.randint(0, WINDOW_SIZE[1])
                self.sparkels_1.append([kint,iintto,posinit])
                ittt=ittt+1
            iintto=iintto+self.background_speed_2

        iintto2=0
        while iintto2<=WINDOW_SIZE[0]:
            lindo=random.randint(0,15)
            if lindo>14:
                self.constelation.add_star()
            iintto2=iintto2+self.background_speed_3
            self.constelation.update()
        
        self.start_sound.play()

    def reset_game(self):
        self.constelation.clear_star()
        self.total_distance=0
        self.was_shot=0
        self.witch_sprite_ship=0
        self.konfett_list = konfetti_tube(WINDOW_SIZE[0])
        self.kon_t=0
        self.warp=1
        self.player_speed=10
        self.background_speed=1
        self.bullet_speed=12
        self.torpedo_speed=11

        self.asteroid_min_speed=8
        self.asteroid_max_speed=8
        
        self.background_speed_T1=0.25
        self.background_speed_T2=0.5

        self.background_speed_2=2
        self.background_speed_3=3

        self.sparkels_1=[]

        iintto=0
        while iintto<=WINDOW_SIZE[0]:
            iinnttt=random.randint(0, 5)
            ittt=0
            while ittt<iinnttt:
                kolor_innit=random.randint(1, 3)
                if kolor_innit==1:
                    kint=(255,255,153)
                elif kolor_innit==2:
                    kint=(204,255,255)
                elif kolor_innit==3:
                    kint=(204,255,204)
                posinit=random.randint(0, WINDOW_SIZE[1])
                self.sparkels_1.append([kint,iintto,posinit])
                ittt=ittt+1
            iintto=iintto+self.background_speed_2
        
        iintto2=0
        while iintto2<=WINDOW_SIZE[0]:
            lindo=random.randint(0,15)
            if lindo>14:
                    self.constelation.add_star()
            iintto2=iintto2+self.background_speed_3
            self.constelation.update()

        self.ship = Ship(x=0, y=WINDOW_SIZE[1]/2, size=self.ship_size, speed=self.player_speed)

        self.bullet_list = Bullet_List()
        self.laser = Laser(self.ship.pos[0], self.ship.pos[1])
        self.torpedo_list = Torpedo_list()
        self.asteroid_list=Asteroid_Belt(min_speed=self.asteroid_min_speed, max_speed=self.asteroid_max_speed)

        self.total_score = 0
        self.game_over = False
        self.game_won=False
        self.menu_is=False
        self.score_board=False
        self.explain=False

        self.time_to_spawn = random.randint(self.spawn_min, self.spawn_max)

        pygame.time.set_timer(self.event_spawn_ateroid, self.time_to_spawn)
        self.has_top_torpedo=True
        self.has_bottom_torpedo=True
        self.pppk=0
        self.kaboo.set_center(self.ship.rect.center)
        self.kaboo.clear()
        self.kaboo=Kaa_Boom(self.ship.rect.center)
        self.start_sound.play()
        self.once=False

    def run(self):
        while self.running:
            while not (self.game_over or self.menu_is or self.game_won or self.score_board or self.explain) :
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        self.running = False
                    if event.type == self.event_spawn_ateroid:
                        self.asteroid_list.spawn_asteroid()
                        self.time_to_spawn = random.randint(self.spawn_min, self.spawn_max)
                        pygame.time.set_timer(self.event_spawn_ateroid, self.time_to_spawn)
                    if event.type==pygame.KEYDOWN:
                        if event.key==pygame.K_SPACE:
                            self.was_shot=3
                            self.bullet_list.add_bullet(
                                self.ship.pos[0]+self.ship.size/2,
                                self.ship.pos[1]+self.ship.size-4,
                                speed=self.bullet_speed
                            )
                            self.bullet_list.add_bullet(
                                self.ship.pos[0]+self.ship.size/2,
                                self.ship.pos[1]+1,
                                speed=self.bullet_speed
                            )
                            self.space_sound.play()
                        if event.key == pygame.K_w:
                            if self.laser.is_ready:
                                self.laser.activate = True
                                if not self.w_loop_channel:  
                                    self.w_loop_channel = self.w_loop_sound.play(-1)
                        if event.key == pygame.K_q:
                            if self.has_top_torpedo:
                                self.q_sound.play()
                                self.torpedo_list.add(
                                    self.ship.pos[0]+self.ship.size/2,
                                    self.ship.pos[1]+12, 
                                    speed=self.torpedo_speed,
                                    size_x=24,
                                    size_y=11
                                )
                                self.has_top_torpedo = False

                        if event.key == pygame.K_e:
                            if self.has_bottom_torpedo:
                                self.q_sound.play()
                                self.torpedo_list.add(
                                    self.ship.pos[0]+self.ship.size/2,
                                    self.ship.pos[1]+self.ship.size-22, 
                                    speed=self.torpedo_speed,
                                    size_x=24,
                                    size_y=11
                                )
                                self.has_bottom_torpedo = False
                        if event.key == pygame.K_y:
                            self.total_distance=self.total_distance+1000
                        if event.key == pygame.K_u:
                            self.total_score=self.total_score+10000
                    if event.type == pygame.KEYUP:
                        if event.key == pygame.K_w:
                            if self.w_loop_channel:
                                self.w_loop_channel.stop()
                                self.w_loop_channel = None

                keys = pygame.key.get_pressed()

                self.ship.move(keys)
                self.ship.update()

                self.screen.fill('black')
                if self.warp>=10:
                    self.game_won=True
                if self.game_won:
                    self.won_sound.play()
                self.bullet_list.update()
                self.asteroid_list.update()

                pkt1=self.laser.update(self.asteroid_list, self.ship.rect.center)
                pkt2=self.torpedo_list.update(self.asteroid_list)

                pkt = self.asteroid_list.collision_bullet(self.bullet_list)
                collision_happened = self.asteroid_list.collision_player(self.ship)
                if collision_happened:
                    self.ship.collision_check()
                    if self.ship.hp <= 0:
                        self.game_over = True
                        self.game_over_sound.play()

                pick = self.asteroid_list.collision_pickup(self.ship)
                pick_sound = pygame.mixer.Sound('music\pickup.mp3')
                for pickup_type in pick:
                    pick_sound.play()
                    if pickup_type == 'torpedo':
                        if not self.has_top_torpedo:
                            self.has_top_torpedo = True
                        elif not self.has_bottom_torpedo:
                            self.has_bottom_torpedo = True
                    elif pickup_type == 'heart':
                        self.ship.hp += 2
                        if self.ship.hp > 6:
                            self.ship.hp = 6
                    elif pickup_type == 'star':
                        self.total_score += 5000

                self.background_x_T1 =self.background_x_T1 - self.background_speed_T1
                self.background_x_T2 =self.background_x_T2 - self.background_speed_T2



                if self.background_x_T1 <= -self.background_width:
                    self.background_x_T1 = 0
                self.screen.blit(self.background_T1, (self.background_x_T1, 0))
                self.screen.blit(self.background_T1, (self.background_x_T1 + self.background_width, 0))

                if self.background_x_T2 <= -self.background_width:
                    self.background_x_T2 = 0
                self.screen.blit(self.background_T2, (self.background_x_T2, 0))
                self.screen.blit(self.background_T2, (self.background_x_T2 + self.background_width, 0))

                iinnttt=random.randint(0, 5)

                ittt=0
                while ittt<iinnttt:
                    kolor_innit=random.randint(1, 3)
                    if kolor_innit==1:
                        kint=(255,255,153)
                    elif kolor_innit==2:
                        kint=(204,255,255)
                    elif kolor_innit==3:
                        kint=(204,255,204)
                    posinit=random.randint(0, WINDOW_SIZE[1])
                    self.sparkels_1.append([kint,WINDOW_SIZE[0],posinit])
                    ittt=ittt+1


                lindo=random.randint(0,15)
                if lindo>14:
                    self.constelation.add_star()
         

                for sparke in self.sparkels_1[:]:
                    radd=random.randint(0,150)
                    kolor_tmp=[]
                    for kol in sparke[0]:
                        if kol==0:
                            kolor_tmp.append(kol+radd)
                        else:
                            kolor_tmp.append(kol)
                    sparke[1]=sparke[1]-self.background_speed_2
                    if sparke[1]<=0:
                        self.sparkels_1.remove(sparke)
                    sparkerec=pygame.Rect(sparke[1],sparke[2],2,2)
                    pygame.draw.rect(self.screen,kolor_tmp,sparkerec)

                self.constelation.draw(self.screen)
                self.constelation.update()

                self.laser.draw(self.screen)

                self.witch_sprite_ship=self.witch_sprite_ship+1

                if self.witch_sprite_ship==16:
                    self.witch_sprite_ship=0

                if self.was_shot!=0:
                    self.screen.blit(self.sprite_ship_shot,(self.ship.pos[0]-16,self.ship.pos[1]-8))
                    self.was_shot=self.was_shot-1
                self.bullet_list.draw(self.screen)
                self.torpedo_list.draw(self.screen)
                self.asteroid_list.draw(self.screen)
                if self.ship.is_visible():
                    if self.has_top_torpedo and self.has_bottom_torpedo:
                        self.screen.blit(self.sprite_ship_both_torpedo, (self.ship.pos[0]-16, self.ship.pos[1]-8))
                    elif self.has_top_torpedo:
                        self.screen.blit(self.sprite_ship_up_torpedo, (self.ship.pos[0]-16, self.ship.pos[1]-8))
                    elif self.has_bottom_torpedo:
                        self.screen.blit(self.sprite_ship_down_torpedo, (self.ship.pos[0]-16, self.ship.pos[1]-8))

                    self.screen.blit(self.statek_sprites[int(math.floor(self.witch_sprite_ship/4))], (self.ship.pos[0]-16,self.ship.pos[1]-8))

                text_fps = self.font1.render("FPS: %3.1f" % self.clock.get_fps(),True,'white')
                self.screen.blit(text_fps,(24,24))
                text_score = self.font1.render("Score: " + str(self.total_score),True,'white')
                self.screen.blit(text_score,(24,48))
                text_warp = self.font1.render("WARP: " + str(self.warp),True,'white')
                self.screen.blit(text_warp,(24,96))
                text_hp = self.font1.render(f"HP: {self.ship.hp/2}/3", True, 'white')
                self.screen.blit(text_hp, (240, 96))
                self.total_distance=self.total_distance+1
                text_distance = self.font1.render(f"Distance: {self.total_distance}", True, 'white')
                self.screen.blit(text_distance, (24, 72))
                
                if self.laser.activate:
                    usage_percent = int( ((self.laser.usage_time - self.laser.current_usage) / self.laser.usage_time) * 100 )
                    text_laser_active = self.font1.render(f"Laser Active: {usage_percent}%",True,'white')
                    self.screen.blit(text_laser_active,(240,24))
                elif self.laser.is_charging:
                    charge_percent = int( (self.laser.current_charge / self.laser.charge_time) * 100 )
                    text_laser_charging = self.font1.render(f"Laser Charging: {charge_percent}%",True,'white')
                    self.screen.blit(text_laser_charging,(240,24))
                else:
                    text_laser_on = self.font1.render("Laser Ready",True,'white')
                    self.screen.blit(text_laser_on,(240,24))
                current_torpedos=0
                if self.has_bottom_torpedo:
                    current_torpedos=current_torpedos+1
                if self.has_top_torpedo:
                    current_torpedos=current_torpedos+1
                text_torpedos = self.font1.render(f"Torpedos: {current_torpedos}/2",True,'white')
                self.screen.blit(text_torpedos,(240,48))
                self.total_score=self.total_score+1+(pkt+pkt1+pkt2)*250+self.pppk
                self.pppk=0
                self.constelation.speed_up(self.background_speed_3)
                self.kaboo.set_center(self.ship.rect.center)
                self.screen_image = self.screen.copy()

                self.clock.tick(60)

                if self.warp!=math.ceil(self.total_distance/1000):
                    self.player_speed=self.player_speed+ 0.5
                    self.ship.speed = self.player_speed

                    self.background_speed_T1=self.background_speed_T1+0.5
                    self.background_speed_T2=self.background_speed_T2+0.5

                    self.background_speed_2 =self.background_speed_2+ 0.5
                    self.background_speed_3 =self.background_speed_3+ 0.5

                    self.bullet_speed =self.bullet_speed+ 0.5
                    self.torpedo_speed =self.torpedo_speed+ 0.5

                    self.asteroid_min_speed= self.asteroid_min_speed + 0.5
                    self.asteroid_max_speed= self.asteroid_max_speed+ 0.5

                    self.asteroid_list.min_speed = self.asteroid_min_speed
                    self.asteroid_list.max_speed = self.asteroid_max_speed
                    
                    for asteroid in self.asteroid_list.asteroids:
                        asteroid.speed =asteroid.speed+ 0.5 
                    for bullet in self.bullet_list.bullets:
                        bullet.speed=bullet.speed+ 0.5
                    for torpedo in self.torpedo_list.torpedos:
                        torpedo.speed=torpedo.speed+ 0.5
                    self.warp=math.ceil(self.total_distance/1000)
                    
                pygame.display.flip()

            while self.running and self.game_over:
                
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        self.running = False
                    if event.type == pygame.KEYDOWN:
                        if event.key == pygame.K_r:
                            self.reset_game()
                        if event.key == pygame.K_l:
                            self.running = False
                        if event.key ==pygame.K_m:
                            self.game_won = False
                            self.game_over = False
                            self.menu_is = True
                    if event.type == pygame.MOUSEBUTTONDOWN:
                        mouse_pos = pygame.mouse.get_pos()
                        if text_restart.click(mouse_pos):
                            self.reset_game()
                        if text_quit.click(mouse_pos):
                            self.running = False
                        if text_menu.click(mouse_pos):
                            self.game_won = False
                            self.game_over = False
                            self.menu_is = True

                mouse_pos = pygame.mouse.get_pos()

                self.screen.blit(self.screen_image, (0, 0))
                self.kaboo.draw(self.screen)
                text_gameover=self.font2.render("GAME OVER",True,'white')
                self.screen.blit(text_gameover,(WINDOW_SIZE[0]/2-text_gameover.get_width()/2,WINDOW_SIZE[1]*0.3))
                if self.once==False and self.game_over == True:
                    update_high_score(self.total_score)
                    self.once=True
                
                text_score = self.font1.render("Total Score: " + str(self.total_score),True,'white')
                self.screen.blit(text_score,(WINDOW_SIZE[0]/2-text_score.get_width()/2,WINDOW_SIZE[1]*0.6))
                text_restart=clicable_tekst("Press 'R' to Restart",self.font1,WINDOW_SIZE[0]/2,WINDOW_SIZE[1]*0.7)
                text_restart.update(mouse_pos)
                text_restart.draw(self.screen)
                text_quit=clicable_tekst("Press to 'L' Quit",self.font1,WINDOW_SIZE[0]/2,WINDOW_SIZE[1]*0.8)
                text_quit.update(mouse_pos)
                text_quit.draw(self.screen)
                text_menu=clicable_tekst("Press 'M' to go back to Menu",self.font1,WINDOW_SIZE[0]/2,WINDOW_SIZE[1]*0.9)
                text_menu.update(mouse_pos)
                text_menu.draw(self.screen)
                pygame.display.flip()
                self.clock.tick(60)
            while self.running and self.game_won:
                
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        self.running = False
                    if event.type == pygame.KEYDOWN:
                        if event.key == pygame.K_r:
                            self.reset_game()
                        if event.key == pygame.K_l:
                            self.running = False
                        if event.key ==pygame.K_m:
                            self.game_won = False
                            self.game_over = False
                            self.menu_is = True
                    if event.type == pygame.MOUSEBUTTONDOWN:
                        mouse_pos = pygame.mouse.get_pos()
                        if text_restart.click(mouse_pos):
                            self.reset_game()
                        if text_quit.click(mouse_pos):
                            self.running = False
                        if text_menu.click(mouse_pos):
                            self.game_won = False
                            self.game_over = False
                            self.menu_is = True
                self.screen.fill('black')
                if self.kon_t<120:
                    self.konfett_list.create_row()
                
                mouse_pos = pygame.mouse.get_pos()
                self.konfett_list.update()
                self.kon_t=self.kon_t+1
                self.konfett_list.draw(self.screen)
                text_gameover=self.font2.render("GAME WON",True,'white')
                self.screen.blit(text_gameover,(WINDOW_SIZE[0]/2-text_gameover.get_width()/2,WINDOW_SIZE[1]*0.3))
                if self.once==False and self.game_won == True:
                    update_high_score(self.total_score)
                    self.once=True
                text_score = self.font1.render("Total Score: " + str(self.total_score),True,'white')
                self.screen.blit(text_score,(WINDOW_SIZE[0]/2-text_score.get_width()/2,WINDOW_SIZE[1]*0.6))

                text_restart=clicable_tekst("Press 'R' to Restart",self.font1,WINDOW_SIZE[0]/2,WINDOW_SIZE[1]*0.7)
                text_restart.update(mouse_pos)
                text_restart.draw(self.screen)
                text_quit=clicable_tekst("Press to 'L' Quit",self.font1,WINDOW_SIZE[0]/2,WINDOW_SIZE[1]*0.8)
                text_quit.update(mouse_pos)
                text_quit.draw(self.screen)
                text_menu=clicable_tekst("Press 'M' to go back to Menu",self.font1,WINDOW_SIZE[0]/2,WINDOW_SIZE[1]*0.9)
                text_menu.update(mouse_pos)
                text_menu.draw(self.screen)
                pygame.display.flip()
                self.clock.tick(60)

            while self.running and self.menu_is:
                
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        self.running = False
                    if event.type == pygame.KEYDOWN:
                        if event.key == pygame.K_r:
                            self.reset_game()
                        if event.key == pygame.K_l:
                            self.running = False
                        if event.key == pygame.K_d:
                            self.game_won = False
                            self.game_over = False
                            self.score_board = True
                            self.explain=False
                            self.menu_is=False
                        if event.key == pygame.K_g:
                            self.game_won = False
                            self.game_over = False
                            self.score_board = False
                            self.explain=True
                            self.menu_is=False
                    if event.type == pygame.MOUSEBUTTONDOWN:
                        mouse_pos = pygame.mouse.get_pos()
                        if text_start.click(mouse_pos):
                            self.reset_game()
                        if text_quit.click(mouse_pos):
                            self.running = False
                        if text_score.click(mouse_pos):
                            self.game_won = False
                            self.game_over = False
                            self.score_board = True
                            self.explain=False
                            self.menu_is=False
                        if text_guide.click(mouse_pos):
                            self.game_won = False
                            self.game_over = False
                            self.score_board = False
                            self.explain=True
                            self.menu_is=False
                            
                self.screen.fill('black')

                text_gameover=self.font3.render("SPACE TREK",True,'white')
                self.screen.blit(text_gameover,(WINDOW_SIZE[0]/2-text_gameover.get_width()/2,WINDOW_SIZE[1]*0.3))
                mouse_pos = pygame.mouse.get_pos()
                text_score=clicable_tekst("Press 'D' to See Higest score",self.font1,WINDOW_SIZE[0]/2,WINDOW_SIZE[1]*0.6)
                text_score.update(mouse_pos)
                text_score.draw(self.screen)
                
                text_start = clicable_tekst("Press 'R' to Start",self.font1,WINDOW_SIZE[0]/2,WINDOW_SIZE[1]*0.5)
                text_start.update(mouse_pos)
                text_start.draw(self.screen)

                text_guide = clicable_tekst("Press 'G' to Guide",self.font1,WINDOW_SIZE[0]/2,WINDOW_SIZE[1]*0.7)
                text_guide.update(mouse_pos)
                text_guide.draw(self.screen)

                text_quit = clicable_tekst("Press 'L' to Quit",self.font1,WINDOW_SIZE[0]/2,WINDOW_SIZE[1]*0.8)
                text_quit.update(mouse_pos)
                text_quit.draw(self.screen)

                pygame.display.flip()
                self.clock.tick(60)

            while self.running and self.score_board:
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        self.running = False
                    if event.type == pygame.KEYDOWN:
                        if event.key ==pygame.K_m:
                            self.game_won = False
                            self.game_over = False
                            self.menu_is = True
                            self.score_board=False
                    if event.type == pygame.MOUSEBUTTONDOWN:
                        mouse_pos = pygame.mouse.get_pos()
                        if text_menu.click(mouse_pos):
                            self.game_won = False
                            self.game_over = False
                            self.menu_is = True
                            self.score_board=False
                self.screen.fill('black')

                text_gameover=self.font2.render("SCORE BOARD",True,'white')
                self.screen.blit(text_gameover,(WINDOW_SIZE[0]/2-text_gameover.get_width()/2,WINDOW_SIZE[1]*0.1))
                i=1
                lscore=get_high_score()
                while i<6:
                    if len(lscore)<i:
                        text_dashbor = self.font1.render(str(i)+'. __________',True,'white')
                        self.screen.blit(text_dashbor,(WINDOW_SIZE[0]/2-200,WINDOW_SIZE[1]*(i+2)*0.1))
                    else:
                        text_dashbor = self.font1.render(str(i)+'. '+str(lscore[i-1]),True,'white')
                        self.screen.blit(text_dashbor,(WINDOW_SIZE[0]/2-200,WINDOW_SIZE[1]*(i+2)*0.1))
                    i=i+1
                while i<11:
                    if len(lscore)<i:
                        text_dashbor = self.font1.render(str(i)+'. __________',True,'white')
                        self.screen.blit(text_dashbor,(WINDOW_SIZE[0]/2+40,WINDOW_SIZE[1]*(i+2-5)*0.1))
                    else:
                        text_dashbor = self.font1.render(str(i)+'. '+str(lscore[i-1]),True,'white')
                        self.screen.blit(text_dashbor,(WINDOW_SIZE[0]/2+40,WINDOW_SIZE[1]*(i+2-5)*0.1))
                    i=i+1
                mouse_pos = pygame.mouse.get_pos()
                text_menu=clicable_tekst("Press 'M' to go back to Menu",self.font1,WINDOW_SIZE[0]/2,WINDOW_SIZE[1]*0.9)
                text_menu.update(mouse_pos)
                text_menu.draw(self.screen)

                pygame.display.flip()
                self.clock.tick(60)
                
            while self.running and self.explain:
                for event in pygame.event.get():
                    if event.type == pygame.QUIT:
                        self.running = False
                    if event.type == pygame.KEYDOWN:
                        if event.key ==pygame.K_m:
                            self.game_won = False
                            self.game_over = False
                            self.menu_is = True
                            self.score_board=False
                            self.explain=False
                    if event.type == pygame.MOUSEBUTTONDOWN:
                        mouse_pos = pygame.mouse.get_pos()
                        if text_menu.click(mouse_pos):
                            self.game_won = False
                            self.game_over = False
                            self.menu_is = True
                            self.score_board=False
                            self.explain=False
                self.screen.fill('black')

                text_gameover=self.font2.render("GUIDE",True,'white')
                self.screen.blit(text_gameover,(WINDOW_SIZE[0]/2-text_gameover.get_width()/2,WINDOW_SIZE[1]*0.1))
                text_be1=self.font1.render("After a catastrophic space battle, you find yourself stranded in the dense asteroid belt, ", True, 'white')
                self.screen.blit(text_be1, (WINDOW_SIZE[0]/2-text_be1.get_width()/2, WINDOW_SIZE[1]*0.2))
                text_be2=self.font1.render("surrounded by dangerous rocks. Your ship warp drive is damaged but fixable.", True, 'white')
                self.screen.blit(text_be2, (WINDOW_SIZE[0]/2-text_be2.get_width()/2, WINDOW_SIZE[1]*0.3))
                text_be3=self.font1.render("To escape and achieve interstellar travel, you must power up your warp drive to Warp 10. ", True, 'white')
                self.screen.blit(text_be3, (WINDOW_SIZE[0]/2-text_be3.get_width()/2, WINDOW_SIZE[1]*0.4))
                text_be4=self.font1.render("Starting from Warp 1, every 1,000 units of distance increases your drive by one.", True, 'white')
                self.screen.blit(text_be4, (WINDOW_SIZE[0]/2-text_be4.get_width()/2, WINDOW_SIZE[1]*0.5))
                text_be5=self.font1.render("Dodge, shoot, and survive the incoming asteroids to reach stars!", True, 'white')
                self.screen.blit(text_be5, (WINDOW_SIZE[0]/2-text_be5.get_width()/2, WINDOW_SIZE[1]*0.6))
                text_be6=self.font1.render("U can move using arrows, use laser with W and shot using SPACE and shot torpedos using Q and E", True, 'white')
                self.screen.blit(text_be6, (WINDOW_SIZE[0]/2-text_be6.get_width()/2, WINDOW_SIZE[1]*0.7))
                text_be7=self.font1.render("U can also find new torpedos, additional score points and hp in destroy asteroids", True, 'white')
                self.screen.blit(text_be7, (WINDOW_SIZE[0]/2-text_be7.get_width()/2, WINDOW_SIZE[1]*0.8))
                mouse_pos = pygame.mouse.get_pos()
                text_menu=clicable_tekst("Press 'M' to go back to Menu",self.font1,WINDOW_SIZE[0]/2,WINDOW_SIZE[1]*0.9)
                text_menu.update(mouse_pos)
                text_menu.draw(self.screen)

                pygame.display.flip()
                self.clock.tick(60)
        pygame.quit()
